#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "pcx.h"
#include "editskin.h"
#include "mouse.h"
#include "ranges.h"
#include "arrow.h"
#include "logo.h"
#include "config.h"

void pinfo(char *s)
{
 es_setfontcolors(conf_pinfo_bg,conf_pinfo_fg);
 es_write(270,HEIGHT-8,s);
}

void es_pixel(int x, int y)
{
 int c;

// IMAGE
 if (RANGE_IMAGE(x,y))
  if (showrealc==0)
   es_setpixel(x,y,C_PALETTE(DATASEARCH(x,y)));
  else
   {
    if (black[x/2+y/2*320]==0 && DATASEARCH(x,y)>=16 && DATASEARCH(x,y)<32)
    {
     if (shirtcolor>8 && shirtcolor<15)
      c=(15-(DATASEARCH(x,y)-16))+(shirtcolor-1)*16;
     else
      c=(DATASEARCH(x,y)-16)+(shirtcolor-1)*16;
    }
    else
    if (black[x/2+y/2*320]==0 && DATASEARCH(x,y)>=96 && DATASEARCH(x,y)<112)
    {
     if (pantcolor>8 && pantcolor<15)
      c=(15-(DATASEARCH(x,y)-96))+(pantcolor-1)*16;
     else
      c=(DATASEARCH(x,y)-96)+(pantcolor-1)*16;
    }
    else
     c=DATASEARCH(x,y);
    es_setpixel(x,y,C_PALETTE(c));
   }
  else
// SHIRT LABEL
 if (RANGE_SHIRTLABEL(x,y))
 {
  es_setfontcolors(conf_shirtlabel_bg,conf_shirtlabel_fg);
  es_write(SHIRTWIDGET_PX,SHIRTWIDGET_PY,"Shirt");
 } else
// SHIRT ARROW_LEFT
 if (RANGE_SHIRTARROWL(x,y))
 {
  if (ARROW_PIC[(11-(x-(SHIRTWIDGET_PX+46)))+(y-(SHIRTWIDGET_PY-4))*(ARROW_SIZE_X+1)]==1)
   es_setpixel(x,y,conf_arrow_fg);
  else
   es_setpixel(x,y,conf_arrow_bg);
 } else
// PANTS LABEL
 if (RANGE_PANTLABEL(x,y))
 {
  es_setfontcolors(conf_pantlabel_bg,conf_pantlabel_fg);
  es_write(PANTWIDGET_PX,PANTWIDGET_PY,"Pants");
 } else
// PANT ARROW_LEFT
 if (RANGE_PANTARROWL(x,y))
 {
  if (ARROW_PIC[(11-(x-(PANTWIDGET_PX+46)))+(y-(PANTWIDGET_PY-4))*(ARROW_SIZE_X+1)]==1)
   es_setpixel(x,y,conf_arrow_fg);
  else
   es_setpixel(x,y,conf_arrow_bg);
 } else
// SHIRT ARROW_RIGHT
 if (RANGE_SHIRTARROWR(x,y))
 {
  if (ARROW_PIC[(x-(SHIRTWIDGET_PX+72))+(y-(SHIRTWIDGET_PY-4))*(ARROW_SIZE_X+1)]==1)
   es_setpixel(x,y,conf_arrow_fg);
  else
   es_setpixel(x,y,conf_arrow_bg);
 } else
// PANT ARROW_RIGHT
 if (RANGE_PANTARROWR(x,y))
 {
  if (ARROW_PIC[(x-(PANTWIDGET_PX+72))+(y-(PANTWIDGET_PY-4))*(ARROW_SIZE_X+1)]==1)
   es_setpixel(x,y,conf_arrow_fg);
  else
   es_setpixel(x,y,conf_arrow_bg);
 } else
// SHIRT EXAMPLE PATCH
 if (RANGE_SHIRTCOLOR(x,y))
 {
  if (shirtcolor>8 && shirtcolor<15)
   c=(shirtcolor-1)*16+1;
  else
   c=(shirtcolor*16)-1;
  es_setpixel(x,y,C_PALETTE(c));
 }
 else
// PANT EXAMPLE PATCH
 if (RANGE_PANTCOLOR(x,y))
 {
  if (pantcolor>8 && pantcolor<15)
   c=(pantcolor-1)*16+1;
  else
   c=(pantcolor*16)-1;
  es_setpixel(x,y,C_PALETTE(c));
 }
 else
// PALETTE
 if (RANGE_PALETTE(x,y))  // 261x80
 { 
  if (PALETTESEARCH(x,y)<256)
   es_setpixelrgb(x,y,
                  palette[ PALETTESEARCH(x,y) *3+0],
                  palette[ PALETTESEARCH(x,y) *3+1],
                  palette[ PALETTESEARCH(x,y) *3+2]);
    else
   es_setpixel(x,y,conf_background);
 } else
// LOGO
 if (RANGE_LOGO(x,y))
 {
#define LOGOSEARCH(x,y) logo_data[x-LOGO_PX+(y-LOGO_PY)*LOGO_SX]

  es_setpixelrgb(x,y,LOGOSEARCH(x,y)*conf_logo_red/100,
                     LOGOSEARCH(x,y)*conf_logo_green/100,
                     LOGOSEARCH(x,y)*conf_logo_blue/100);
 
 } else
// PINFO SLOT
 if (RANGE_PINFO(x,y))
 {
  if (t_pinfo==1)
  {
   pinfo(colorhelp[s_color].name);
   t_pinfo=0;
  }
 } else
// QUIT BUTTON
 if (RANGE_QUITB(x,y))
 {
  es_setfontcolors(es_color(50,50,50),
                   es_color(140,140,180));
  es_write(QUITB_PX,QUITB_PY,"QUIT"); 
 } 
  else
  
// SAVE BUTTON
 if (RANGE_SAVEB(x,y))
 {
  es_setfontcolors(es_color(50,50,50),
                   es_color(180,140,140));
  es_write(SAVEB_PX,SAVEB_PY,"SAVE"); 
 } 
  else
// POINTER SIZE BOX
 if (RANGE_POINTERSIZE(x,y))
 {
  if (x!=600 && x!=598+pointer*2 && 
      y!=440 && y!=438+pointer*2)
   es_setpixel(x,y,C_PALETTE(s_color)); else
   es_setpixel(x,y,C_WHITE);
 } else
// POINTER SIZE CIRCLE
 if (RANGE_POINTERSIZECIRC(x,y))
 {
  if (ROUNDSEARCH(x,y))
   es_setpixel(x,y,C_PALETTE(s_color));
  else
   es_setpixel(x,y,conf_background);
 } else
// EMPTY
 es_setpixel(x,y,conf_background);
}
